' Beispiel fr Labyrinth-Spiel
' Beilage zu http://forum.qbasic.at/viewtopic.php?t=5323

DECLARE SUB TitelAusgabe (t$, h%, f%)

DIM lev%(1 TO 39, 1 TO 24)

SCREEN 0
WIDTH 40, 25

DO
  COLOR 7, 0
  CLS
  TitelAusgabe "Spieltitel", 3, 9
  TitelAusgabe "Start mit Leertaste", 4, 14
  TitelAusgabe "Ende mit Esc", 5, 2
  DO
    t$ = INKEY$
  LOOP WHILE t$ = ""
  IF t$ = " " THEN
    ' Spiel
    level% = 1
    DO
      COLOR 7, 0
      CLS
      TitelAusgabe "Level" + STR$(level%), 13, 15
      d$ = INPUT$(1)
      OPEN "level" + LTRIM$(STR$(level%)) + ".txt" FOR INPUT AS 1
      FOR i% = 1 TO 24
        LINE INPUT #1, z$
        LOCATE i%, 1
        FOR j% = 1 TO 39
          SELECT CASE MID$(z$, j%, 1)
          CASE "*"
            ' Mauer
            lev%(j%, i%) = 1
            COLOR 12, 5
            PRINT "";
          CASE " "
            ' Leer
            lev%(j%, i%) = 0
            COLOR 7, 0
            PRINT " ";
          CASE "S"
            ' Startpunkt
            lev%(j%, i%) = 0
            COLOR 14, 0
            PRINT CHR$(2);
            xPos% = j%
            yPos% = i%
          CASE "Z"
            ' Zielpunkt
            lev%(j%, i%) = 0
            COLOR 9, 1
            PRINT CHR$(127);
            xZiel% = j%
            yZiel% = i%
          CASE ELSE
            ' nicht definiert (sollte nicht vorkommen)
            lev%(j%, i%) = 2
            COLOR 7, 0
            PRINT "?"
          END SELECT
        NEXT j%
      NEXT i%
      CLOSE 1
      LOCATE 25, 1
      COLOR 7, 0
      PRINT "Level"; level%;

      DO
        DO
          t2$ = INKEY$
        LOOP WHILE t2$ = ""
        SELECT CASE t2$
        CASE CHR$(0) + "H"
          xPos1% = xPos%
          yPos1% = yPos% - 1
        CASE CHR$(0) + "K"
          xPos1% = xPos% - 1
          yPos1% = yPos%
        CASE CHR$(0) + "M"
          xPos1% = xPos% + 1
          yPos1% = yPos%
        CASE CHR$(0) + "P"
          xPos1% = xPos%
          yPos1% = yPos% + 1
        CASE ELSE
          xPos1% = xPos%
          yPos1% = yPos%
        END SELECT
        IF lev%(xPos1%, yPos1%) = 0 THEN
          COLOR 14, 0
          LOCATE yPos%, xPos%
          PRINT " ";
          LOCATE yPos1%, xPos1%
          PRINT CHR$(2);
          xPos% = xPos1%
          yPos% = yPos1%
        ELSE
          SOUND 600, 1
        END IF
      LOOP UNTIL t2$ = CHR$(27) OR (xPos% = xZiel% AND yPos% = yZiel%)
      IF xPos% = xZiel% AND yPos% = yZiel% THEN
        LOCATE yPos%, xPos%
        COLOR 14, 1
        PRINT CHR$(1);
        COLOR 13, 0
        LOCATE 25, 15
        PRINT "Level komplett!";
        PLAY "o4t160l8ceg>c<geg"
        d$ = INPUT$(1)
        level% = level% + 1
      END IF
    LOOP UNTIL t2$ = CHR$(27)
  END IF
LOOP UNTIL t$ = CHR$(27)

SCREEN 0
WIDTH 80, 25

SUB TitelAusgabe (t$, h%, f%)
  LOCATE h%, 21 - LEN(t$) \ 2
  COLOR f%
  PRINT t$;
END SUB

